<h3>Votre environnement virtuel :</h3>
<div id="cleared"></div>
<div class="card card-info"> 

    <div class="card-body">
        <div id="id_master" class="form-group" style="display: none;">
            <div class="alert alert-warning">
                Image Maître en cours de modification (prudence ...)
            </div>
        </div>
        <div class="form-group form-inline">
            <label for="challenge_name" class="col-lg-4 control-label">Nom :</label>
            <div class="col-lg-8 text-left">
                <samp>__CHALLENGE_NAME__</samp>
            </div>
        </div>
        <div class="form-group form-inline">
            <label for="uuid" class="col-lg-4 control-label">UUID :</label>
            <div class="col-lg-8 text-left">
                <samp>__UUID__</samp>
            </div>
        </div>
        <div class="form-group form-inline">
            <label for="adresse_ip" class="col-lg-4 control-label">Adresse IP :</label>
            <div class="col-lg-8 text-left">
                <samp>__ADDRESS_IP__</samp>
            </div>
        </div>
        
        <div class="form-group form-inline" id="id_time">
            <label for="uptime" id="title_uptime" class="col-lg-4 control-label">Temps de fonctionnement :</label>
            <div class="col-lg-8 text-left">
                <samp id="uptime"></samp>
            </div>
        </div>

        <div class="row">
            <div class="col-md-6">
                <fieldset class='actions'>
                    <legend class='actions-border'>Actions</legend>
                    <div id="buttons" class="btn-group" role="group" aria-label="Actions">
                        <button id="bt_destroy" class="btn btn-danger" type="button" onclick="destroy()" style="display: none;" disabled><i class="fas fa-trash-alt"></i> Détruire</button>
                        <button id="bt_reboot"  class="btn btn-warning" type="button" onclick="reboot()" disabled><i class="fas fa-redo"></i> Redémarrer</button>
                        <button id="bt_novnc"  class="vnc_allowed btn btn-info" onclick=" window.open('__VNC_URL__','_blank')" style="display: none;"><i class="fas fa-desktop" disabled></i> Afficher</button>
                    </div>
                </fieldset>
            </div>
            <div class="col-md-6">
                <fieldset class='state'>
                    <legend class='actions-border'>Etat de l'environnement virtuel</legend>
                        <span class="badge" id="status-vm" style="font-size:20px;"></span>
                        <span class="badge" id="ping-vm" style="font-size:20px;"></span>
                </fieldset>
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                __ISO_FILES__
            </div>
        </div>
        
    </div>

</div>
<script>
    var aliveTimer;
    var id_vm;
    var uuid='__UUID__';
    var master=0;
    var env_ready=false;
    var countdown_enable=false;
    $(document).ready(function() {
        aliveTimer=setInterval(isAliveTimer, 15000);
        // First time
        isAliveTimer();
    });


    function enableBtActions(state=true, vnc_ready=false) {
        $("#bt_destroy").attr("disabled", ! state);
        $("#bt_reboot").attr("disabled", ! state);
        $("#bt_novnc").attr("disabled", ! (state && vnc_ready));
        $("#bt_valid_iso").attr("disabled", ! state);
        $("#id_list_iso").attr("disabled", ! state);
    }

    function changeStateVM(state, ping, vnc, uptime, lifetime, vnc_ready) {
        // wait, before restart, destroy, ...
        if (uptime<10) {
            block();
            setTimeout(unBlock, 8000);
            enableBtActions(false, false);
        } else enableBtActions(state, vnc_ready);

        if (state && ! env_ready && (uptime>60 || ping || vnc_ready)) {
            // virtual env is probably ready, change interval
            clearInterval(aliveTimer);
            aliveTimer=setInterval(isAliveTimer, 60000);
            env_ready=true;
        }

        if(master) {
            $("#bt_destroy").html("<i class='fas fa-stop-circle'></i> Arrêter");
            $('#id_master').show();
        }

        $("#bt_destroy").show();

        if (! countdown_enable && lifetime) {
            // only one shot
            $("#title_uptime").html("Temps restant :");
            countdown_enable=true;
        }

        if (uptime) {
            if (uptime<40) {
                $("#uptime").html("Environnement virtuel en cours de démarrage ...");
            } else if(lifetime) {
                timeleft=Math.max(0, lifetime-uptime);
                if (timeleft > 60) {
                    $("#uptime").html(datehm(timeleft));
                } else {
                    $("#uptime").html("L'environnement virtuel est en cours d'arrêt ...")
                }
                if (timeleft <= 300) {
                    var audio = new Audio('/assets/audio/alert.mp3');
                    audio.play();
                    blink('Attention au temps');
                }
            } else { $("#uptime").html(datehm(uptime)); }
        }

        if (! state) {
            $("#id_time").remove();
            $('#id_master').remove();
            stop();
        }

        if (typeof vnc !== 'undefined') {
            if (vnc) { $('.vnc_allowed').show() } else { $('.vnc_allowed').remove() }
        }
        
        var labelState=$("#status-vm");
        var labelPing=$("#ping-vm");
        if (state) {
            labelState.removeClass("badge-danger");
            labelState.addClass("badge-success");
            labelState.html("<i class='fas fa-play'></i> Démarré");
        } else {
            // virtual env is stopped
            labelState.removeClass("badge-success");
            labelState.addClass("badge-danger");
            labelState.html("<i class='fas fa-stop-circle'></i> Arrêté");
            clearInterval(aliveTimer);
            env_ready=false;
        }
        if (ping){
            labelPing.removeClass("badge-secondary");
            labelPing.addClass("badge-success");
            labelPing.html("<i class='fas fa-check'></i> Ping OK");
        } else {
            labelPing.removeClass("badge-success");
            labelPing.addClass("badge-secondary");
            labelPing.html("<i class='fas fa-times'></i> Ping NOK");
        }
        
    }

    function modeMaintenanceEnabled() {
        messageBoxWarning("Le système est en mode maintenance. Veuillez réessayer plus tard ...");
    };

    function dosDetected() {
        messageBoxWarning("Trop de requêtes. Veuillez réessayer plus tard ...");
    };

    function destroy() {
        var msg="Êtes-vous sûr ? L'environnement virtuel sera détruit de façon irreversible !";
        if (master)
            msg="Êtes-vous sûr de vouloir arrêter la machine virtuelle Maître ?";
        if (confirm(msg)) {
            block();
            $.ajax({
                url: '/api/quit/__VM_ID__',
                dataType: 'json',
                }).done(function (response) {
                    unBlock();
                    if (typeof response.success !== 'undefined') {
                        if (response.success) {
                            messageBoxInfo("Arrêt de l'environnement virtuel : Opération executée");
                        } else {
                            if  (typeof response.maintenance !== 'undefined' && response.maintenance) {
                                modeMaintenanceEnabled();
                                return;
                            }
                            if (typeof response.dos !== 'undefined' && response.dos) {
                                dosDetected();
                                return;
                            }
                            messageBoxError("Erreur lors de la tentative d'arrêt de l'environnement virtuel");
                        }
                        changeStateVM(false, false); // vm is now off
                    }
            });
        }
    };

    function reboot() {
        block();
        $.ajax({
            url: '/api/system_reset/__VM_ID__',
            dataType: 'json',
            }).done(function (response) {
            unBlock();
            if (typeof response.success !== 'undefined') {
                if (response.success) {
                    messageBoxInfo("Redémarrage de l'environnement virtuel : Opération executée");
                } else {
                    if  (typeof response.maintenance !== 'undefined' && response.maintenance)
                        modeMaintenanceEnabled();
                    else if (typeof response.dos !== 'undefined' && response.dos)
                        dosDetected();
                    else
                        messageBoxError("Erreur lors de la tentative de redémarrage de l'environnement virtuel");
                }
            }
        });
    };

    function valide_iso() {
        block();
        $.ajax({
            url: '/api/valide_iso/__VM_ID__?iso='+$("#id_list_iso").val(),
            dataType: 'json',
            }).done(function (response) {
            unBlock();
            if (response.success) {
                messageBoxInfo("Disque ISO : Opération executée");
            } else {
                if  (typeof response.maintenance !== 'undefined' && response.maintenance)
                    modeMaintenanceEnabled();
                else if (typeof response.dos !== 'undefined' && response.dos)
                    dosDetected();
                else
                    messageBoxError("Echec lors de la tentative d'ajout/suppression d'un CD virtuel (ISO)");
            }
        });
    };

    function isAliveTimer() {
        $.ajax({
            url: '/api/isalive/__VM_ID__',
            dataType: 'json',
            }).done(function (response) {
            if (typeof response.success !== 'undefined' && response.alive){
                var lifetime = ((typeof response.lifetime !== 'undefined' && response.lifetime > 0)? response.lifetime : 0);
                master = response.master;
                id_vm = response.vm_id;
                changeStateVM(true, response.ping, response.vnc, response.uptime, lifetime, response.vnc_ready); // vm is on
            } else {
                // DoS check
                if (typeof response.dos !== 'undefined' && response.dos) {
                    return;
                }
                changeStateVM(false, false); // vm is off
                // try to get error msg, if exist
                getErrorMsg();
            }
        });
    };

    function getErrorMsg() {
        $.ajax({
            url: '/api/get_msg_error/'+uuid,
            dataType: 'json',
            }).done(function (response) {
            if (typeof response.success !== 'undefined' && response.success){
                if (typeof response.msg !== 'undefined' && response.msg!==''){
                    messageBoxError(response.msg.replace(/(?:\r\n|\r|\n)/g, '<br>'));
                }
            }
        });
    };

    </script>
